import sys
from itertools import zip_longest
from typing import TextIO, Dict, Tuple

from qosagg.codegen.aggregating_graph_visitor import AggregatingGraphVisitor
from qosagg.codegen.base_minizinc_generator import BaseMiniZincGenerator, MiniZincGeneratorConfig
from qosagg.codegen.categories.category_generator import CategoryGenerator
from qosagg.codegen.checkpoints.checkpoint_generator import CheckpointGenerator
from qosagg.codegen.choice_variables_generating_graph_visitor import ChoiceVariablesGeneratingGraphVisitor
from qosagg.codegen.graph_collector import GraphCollector
from qosagg.codegen.naming_strategy import PrefixNamingStrategy
from qosagg.codegen.output.output_generator import OutputGenerator
from qosagg.codegen.reachability.reachability_generator import ReachabilityGenerator
from qosagg.domain.aggregation import Aggregation
from qosagg.domain.provision import Provision
from qosagg.domain.task_instance_visitor import TaskInstanceVisitor
from qosagg.domain.unrolling.task_instance import Iteration
from qosagg.domain.unrolling.unrolled_graph import TaskInstance, UGraph
from qosagg.domain.workflow import NamedWorkflow
from qosagg.user_input_error import UserInputError
from qosagg.util.combination_generator import generate_combinations


class MiniZincGenerator(BaseMiniZincGenerator):
    def __init__(self, workflow: NamedWorkflow[UGraph], file: TextIO = sys.stdout,
                 config: MiniZincGeneratorConfig = None) -> None:
        super().__init__(file, config if config is not None else MiniZincGeneratorConfig(),
                         PrefixNamingStrategy(workflow.name))
        self.workflow = workflow
        self.graph_collector = GraphCollector(workflow.graph)

    def generate(self) -> None:
        self.file.write(f"% code generated by QosAgg for workflow {self.workflow.name}\n\n")
        self.file.write("% declarations\n")
        self._generate_declarations()
        self.file.write("\n% attribute assignments\n")
        self._generate_attribute_assignments()
        self.file.write("\n% selection attributes\n")
        self._generate_selection_qos()
        self.file.write("\n% aggregations\n")
        self._generate_aggregations()
        self.file.write("\n% constraints\n")
        self._generate_constraints()
        if self.config.reachability:
            self.file.write("\n% reachability\n")
            ReachabilityGenerator(self.workflow.graph, self.file, self.config, self.naming, self.graph_collector) \
                .generate_reachability()
        if self.config.checkpoints:
            self.file.write("\n% checkpoints\n")
            CheckpointGenerator(self.workflow, self.file, self.config, self.naming, self.graph_collector) \
                .generate_checkpoints()
        if self.config.categories:
            self.file.write("\n% categories\n")
            CategoryGenerator(self.workflow, self.file, self.config, self.naming).generate_categories()
        if self.config.output:
            self.file.write("\n% output\n")
            OutputGenerator(self.workflow, self.file, self.config, self.naming).generate_output()

    # region declarations
    def _generate_declarations(self) -> None:
        self.generate_enum(self.naming.name_provision_enum(),
                           [self.naming.name_provision(p) for p in self.workflow.provisions])
        self.generate_enum(self.naming.name_task_enum(),
                           [self.naming.name_task(t) for t in sorted(self.workflow.get_tasks())])
        self.generate_enum(self.naming.name_task_instance_enum(),
                           [self.naming.name_task_instance(inst) for inst in
                            self.graph_collector.task_instances])
        self.generate_array(self.naming.name_task_instance_enum(),
                            self.naming.name_task_inst_task_map(),
                            [self.naming.name_task(inst.task_occ.task) for inst in self.graph_collector.task_instances],
                            array_type=self.naming.name_task_enum())
        if self.config.taskinst_mapping:
            self._generate_task_inst_mapping()
        self._generate_selection_declaration()
        self._generate_provision_sets()
        self._generate_choice_declaration()

    def _generate_task_inst_mapping(self) -> None:
        for task in self.graph_collector.task_instances_by_task:
            array_name = self.naming.name_task_task_inst_map(task)
            array_type = self.naming.name_task_instance_enum()

            # group iterations and find at the same time calculate index sets
            by_iteration: Dict[Iteration, TaskInstance] = dict()
            loop_counts: Tuple[int, ...] = tuple()
            for ti in self.graph_collector.task_instances_by_task[task]:
                by_iteration[ti.iteration] = ti
                loop_counts = (*(max(x) for x in zip_longest(loop_counts, ti.iteration, fillvalue=0)),)
            dimensions = len(loop_counts)
            if dimensions == 0 or dimensions > 6:
                # no need for an additional array for tasks not inside loops
                # and can not declare arrays with more than 6 index sets
                continue

            # put together values and index
            array_index = ", ".join([f"1..{i + 1}" for i in loop_counts])
            values = [self.naming.name_task_instance(by_iteration[tuple(it)]) for it in
                      generate_combinations((*(i + 1 for i in loop_counts),))]
            joined_values = f"array{dimensions}d({array_index}, [{', '.join(values)}])"

            self.generate_array(array_index, array_name, joined_values, array_type)

    def _generate_selection_declaration(self) -> None:
        self.generate_array(self.naming.name_task_instance_enum(), self.naming.name_selection_array(),
                            array_type=self.naming.name_provision_enum(), variable=True)

    def _generate_provision_sets(self) -> None:
        provision_type = self.naming.name_provision_enum()
        for task in sorted(self.workflow.get_tasks()):
            provisions = [self.naming.name_provision(p) for p in self.workflow.provisions if task in p.tasks]
            name = self.naming.name_provisions_for_task_set(task)
            self.generate_set(name, provisions, set_type=provision_type)

    def _generate_choice_declaration(self) -> None:
        visitor = ChoiceVariablesGeneratingGraphVisitor(self.file, self.naming.name_composite)
        visitor.visit(self.workflow.graph)
        for composite_name in visitor.variables_by_choice:
            agg = visitor.variables_by_choice[composite_name]
            array_name = self.naming.name_composite_inst_array(composite_name)
            self.generate_array(f"1..{len(agg.variables)}", array_name, agg.variables, f"1..{agg.max_options}", True)

    # endregion

    # region assignments
    def _generate_attribute_assignments(self) -> None:
        for attribute in self.workflow.attributes:
            values = [self._find_attribute_value(provision, attribute.name) for provision in self.workflow.provisions]
            self.generate_array(self.naming.name_provision_enum(), self.naming.name_attribute_array(attribute.name),
                                values, array_type=attribute.value_type)

    def _find_attribute_value(self, provision: Provision, attribute: str) -> str:
        try:
            return provision.get_attribute_value(attribute)
        except KeyError:
            # no direct value given, use default value if it exists
            default = self.workflow.get_default_value(attribute)
            if default is not None:
                return default
            raise UserInputError(
                f"Missing value of attribute \"{attribute}\" for provision \"{provision.name}\"")

    # endregion

    # region constraints
    def _generate_constraints(self) -> None:
        TaskInstanceVisitor(self._generate_provisions_constraint_for_task).visit(self.workflow.graph)

    def _generate_provisions_constraint_for_task(self, inst: TaskInstance) -> None:
        inst_name = self.naming.name_task_instance(inst)
        array_access = f"{self.naming.name_selection_array()}[{inst_name}]"
        set_name = self.naming.name_provisions_for_task_set(inst.task_occ.task)
        constraint = f"{array_access} in {set_name}"
        self.generate_constraint(constraint)

    # endregion

    # region aggregations
    def _generate_selection_qos(self) -> None:
        for task_inst in self.graph_collector.task_instances:
            inst_name = self.naming.name_task_instance(task_inst)
            for attribute in self.workflow.attributes:
                var_name = self.naming.name_selection_attribute(task_inst, attribute.name)
                attribute_array = self.naming.name_attribute_array(attribute.name)
                selection_array = self.naming.name_selection_array()
                value = f"{attribute_array}[{selection_array}[{inst_name}]]"
                self.generate_var(var_name, value, attribute.value_type)

    def _get_aggregator(self, aggregation: Aggregation) -> AggregatingGraphVisitor:
        return AggregatingGraphVisitor(aggregation, self.naming)

    def _generate_aggregations(self) -> None:
        for aggregation in sorted(self.workflow.aggregations, key=lambda a: a.attribute_name):
            self._generate_aggregation(aggregation)

    def _generate_aggregation(self, aggregation: Aggregation) -> None:
        name = self.naming.name_aggregation(aggregation)
        visitor = self._get_aggregator(aggregation)
        var_type = self.workflow.attributes_by_name[aggregation.attribute_name].value_type
        self.generate_var(name, visitor.visit(self.workflow.graph), var_type)

    # endregion
